#pragma once

#include "tcs.h"

class CPCOcomm;

class TCScomI :
	public tcs::TCScom
{
public:
	TCScomI(CPCOcomm *pPCOcomm);
private:
	CPCOcomm *m_pPCOcomm;
public:

	virtual bool SendCommand(const std::string&, const ::Ice::Current& = ::Ice::Current());

	virtual void RequestInformation(const std::string& request, std::string& information, const Ice::Current& = ::Ice::Current());

    virtual void SendError(const std::string& error, const ::Ice::Current& = ::Ice::Current());

    virtual void SendNotification(const std::string& notification, const ::Ice::Current& = ::Ice::Current());

    virtual void SendReply(const std::string& reply, const ::Ice::Current& = ::Ice::Current());

    virtual void Register(const std::string& systemName, const ::Ice::Current& = ::Ice::Current());

    virtual void Unregister(const std::string& systemName, const ::Ice::Current& = ::Ice::Current());
};

typedef IceUtil::Handle<TCScomI> TCScomIPtr;